var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "te-config.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
        
        // public method for url encoding
        encode : function (string) {
            string = string.replace(/\r\n/g,"\n");
            var utftext = "";
     
            for (var n = 0; n < string.length; n++) {
     
                var c = string.charCodeAt(n);
     
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
     
            }
     
            return utftext;
        },
     
        // public method for url decoding
        decode : function (utftext) {
            var string = "";
            var i = 0;
            var c = 0;
            var c1 = 0;
            var c2 = 0;
     
            while ( i < utftext.length ) {
     
                c = utftext.charCodeAt(i);
     
                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                }
                else if((c > 191) && (c < 224)) {
                    c2 = utftext.charCodeAt(i+1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else {
                    c2 = utftext.charCodeAt(i+1);
                    c3 = utftext.charCodeAt(i+2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }
     
            }
     
            return string;
        }
     
    };




function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('entries/' + path, value);
        Property.setFlag('entries/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function conversionNeeded(fromVersion, toVersion) {
            if (fromVersion >= toVersion) {
                return false;
            } else {
                return true;    
            }
}

/**
 * Converts all action entries in this subnode to new dsuid where appropriate
 * @param {Object} actions property tree subnode 'actions'
 * @returns {Boolean} true if at least one action was converted
 */
function updateActions2dSUID(actions) {
    try {
        var fMigrate=false;
        var dSID,dSUID;
        var subPropArray = actions.getChildren();
        lInfo.logln('Update action entries from dsid to dsuid');
        for (var iIndex = 0; iIndex < subPropArray.length; iIndex++) {
            switch (subPropArray[iIndex].getChild('type').getValue()) {
                case 'device-scene': //intent fallthrough
                case 'device-blink': //intent fallthrough
                case 'device-value':
                    {   
                        if (subPropArray[iIndex].getChild('dsid')!=null) { 
                            dSID = subPropArray[iIndex].getChild('dsid').getValue();
                            lInfo.logln('-- dsid: ' + dSID);
                            dSUID = dSID2dSUID(dSID);
                            lInfo.logln('-- to dsuid: ' + dSUID);
                            Property.setProperty(subPropArray[iIndex].getPath()+'/dsuid',dSUID);
                            Property.setFlag(subPropArray[iIndex].getPath()+'/dsuid','ARCHIVE',true);
                            subPropArray[iIndex].removeChild('dsid');
                            fMigrate = true;
                        }
                    }
                    break;
                case 'change-state':
                    {
                        var actionName = subPropArray[iIndex].getChild('name').getValue();
                        var nameArray = actionName.split('.');
                        if ((nameArray[0] === 'dev') && (nameArray[1].length === 24)) {
                            var dsuid = dSID2dSUID(nameArray[1]);
                            actionName = '';
                            actionName = actionName.concat(nameArray[0],'.', dsuid, '.', nameArray[2]);
                            Property.setProperty(subPropArray[iIndex].getPath() + '/name', actionName);
                            Property.setFlag(subPropArray[iIndex].getPath()+'/name','ARCHIVE',true);
                            fMigrate=true;
                        }
                    
                    }
                    break;
                default: {lInfo.logln('--default nothing to do');}                
            }
        }
        return fMigrate;
    } catch (e) {
        lWarn.logln('Exception in backward-compatibility::updateActions2dSUID: ' + e);
        return fMigrate;
    }
}

/**
 * Converts all condition entries in this subnode to new dsuid where appropriate
 * @param {Object} condition property tree subnode 'conditions'
 * @returns {Boolean} true if at least one action was converted
 */
function updateConditions2dSUID(conditions) {
    try {
        var fMigrate=false;
        lInfo.logln('Update condition entries from dsid to dsuid');
        var statesNode = conditions.getChild('states');
        if (statesNode != null ) {
            var statesArray = statesNode.getChildren();
            for (var jIndex = 0; jIndex < statesArray.length; jIndex++) {
                var stateName = statesArray[jIndex].getName();
                var stateValue = statesArray[jIndex].getValue();
                var nameArray = stateName.split('.');
                if ((nameArray[0] === 'dev') && (nameArray[1].length === 24)) {
                    var dsuid = dSID2dSUID(nameArray[1]);
                    lInfo.logln('Update from dsid ' + nameArray[1] +  ' to dsuid ' + dsuid);
                    newStateName = '';
                    newStateName = newStateName.concat('/',nameArray[0],'.', dsuid, '.', nameArray[2]);
                    Property.setProperty(statesNode.getPath() + newStateName, stateValue); 
                    Property.setFlag(statesNode.getPath() + newStateName,'ARCHIVE',true);
                    lInfo.logln('set Property ' + statesNode.getPath() + newStateName+' to value '+stateValue);
                    statesNode.removeChild(stateName);
                    lInfo.logln('remove child  ' + stateName);
                    fMigrate=true;
                }
            }
        }

        return fMigrate;
    } catch (e) {
        lWarn.logln('Exception in backward-compatibility::updateConditions2dSUID: ' + e);
        return fMigrate;
    }    
}

/**
 * Iterates trough all entries and convert dsid to dsuid where appropriate
 * @returns {undefined}
 */
function convertdSID2dSUID() {
    var iIndex;
    var subPropArray;
    var fMigrate=false;
    var tmpResult;
    var basePropertyArray = Property.getNode('entries');
    if (basePropertyArray !== null) {
        subPropArray = basePropertyArray.getChildren();
        for (iIndex = 0; iIndex < subPropArray.length; iIndex++) {
            tmpResult = updateActions2dSUID(subPropArray[iIndex].getChild('actions'));
            fMigrate = fMigrate || tmpResult;
            tmpResult = updateConditions2dSUID(subPropArray[iIndex].getChild('conditions'));
            fMigrate = fMigrate || tmpResult;
        }
    }
    if (fMigrate) {
        Property.store();
    } else {
        lInfo.logln('updateDSID2DSUID - nothing to update');
    }    
}

function updateData() {
    Property.load();
    try 
    {
        var version = '1.3.3';
        var versionNode = Property.getNode('version');
        if (versionNode!=null) {
            var currentVersion = versionNode.getValue();
            if (conversionNeeded(currentVersion, '1.2.0')) {
                var oArray=versionNode.getValue().split('.').map(JSON.parse);
                if (oArray.length==4) {
                    var entryNodes = Property.getNode('entries');
                    lInfo.logln("UpdateDataStart 1.0.0.8 -> 1.2.0");

                    if (entryNodes!=null) {
                        lInfo.logln("1");
                        var oEntryArray=entryNodes.getChildren();
                        for (var iIndex=0;iIndex < oEntryArray.length;iIndex++) {
                            lInfo.logln("a" + iIndex);
                            var oEntryNode=oEntryArray[iIndex];
                            var sName=Utf8.decode(oEntryNode.getChild('name').getValue());  
                            lInfo.logln(oEntryNode.getPath() +'/name : ' + sName);
                            Property.setProperty(oEntryNode.getPath() +'/name' , sName);
                        }
                    }
                }        
            }
            if (conversionNeeded(currentVersion, '1.3.3')) {
                convertdSID2dSUID();
            }
        }
        Property.setProperty('version' , version);
        Property.setFlag('version', 'ARCHIVE', true);
        Property.store();
    }
    catch (e)
    {
        lWarn.logln("Fehler beim Namensupgrade " + e);
    }        
    
    var baseNodes = Property.getNode('events');
    lInfo.logln("UpdateDataStart");
    if (baseNodes == null) {
        lInfo.logln("nothing to Update");
        var evt = new Event("system-addon-timed-events.running", {});
        evt.raise();
        return;
    }    
    var fError=false;
    var fAnythingDone=false;
    var oBaseArray=baseNodes.getChildren();
    for ( var iIndex = 0; iIndex < oBaseArray.length; iIndex++) {
        fAnythingDone=true;
        lInfo.logln("found #" + iIndex);
        var oNewID=getNewIdValue();
        lInfo.logln("using id " + oNewID);
        try 
        {
            var oTriggerNode=oBaseArray[iIndex];
            var sName=unescape(oTriggerNode.getChild('name').getValue());         
            lInfo.logln("Name: " + sName);
            var fDisabled=oTriggerNode.getChild('disabled').getValue();
            lInfo.logln("fDisabled: " + fDisabled);
            storeSubParameter(oNewID + '/name', sName);            
            storeSubParameter(oNewID + '/id', oNewID);
            
            if (fDisabled)
                storeSubParameter(oNewID + '/conditions/enabled', false);
            else
                storeSubParameter(oNewID + '/conditions/enabled', true);
            
            var oActionNodes=oTriggerNode.getChild('actions').getChildren();
            for (var jIndex=0;jIndex<oActionNodes.length;jIndex++) {
                var oActionNode=oActionNodes[jIndex];
                if (oActionNode.getChild('device')!=null) {
                    //device calls
                    if (oActionNode.getChild('blink')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('device').getValue() + " blink");
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'device-blink');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/dsid', oActionNode.getChild('device').getValue());
                    } else if (oActionNode.getChild('outputValue')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('device').getValue() + " outvalue " + oActionNode.getChild('outputValue').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'device-value');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/dsid', oActionNode.getChild('device').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/value', oActionNode.getChild('outputValue').getValue());
                    } else if (oActionNode.getChild('scene')!=null){
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('device').getValue() + " scene " +oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'device-scene');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/dsid', oActionNode.getChild('device').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/scene', oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/force', false);
                    }
                } else {
                    // zone calls
                    if (oActionNode.getChild('blink')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('zone').getValue() + " " + oActionNode.getChild('group').getValue() + " blink");
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'zone-blink');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/zone', oActionNode.getChild('zone').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/group', oActionNode.getChild('group').getValue());
                    } else if (oActionNode.getChild('outputValue')!=null) {
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('zone').getValue() + " " + oActionNode.getChild('group').getValue() + " outvalue " + oActionNode.getChild('outputValue').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'zone-value');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/zone', oActionNode.getChild('zone').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/group', oActionNode.getChild('group').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/value', oActionNode.getChild('outputValue').getValue());
                    } else if (oActionNode.getChild('scene')!=null){
                        lInfo.logln("Action #" + jIndex + " on : " + oActionNode.getChild('zone').getValue() + " " + oActionNode.getChild('group').getValue() +  " scene " +oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/type', 'zone-scene');
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/zone', oActionNode.getChild('zone').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/group', oActionNode.getChild('group').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/scene', oActionNode.getChild('scene').getValue());
                        storeSubParameter(oNewID + '/actions/' + jIndex + '/force', false);
                    }                    
                }
            }            
          
            if (oTriggerNode.getChild('recurring').getValue()) {
                // wiederholung
              //time : timebase: 'absolute', 'daily', 'sunrise', 'sunset' | offset: seconds
                storeSubParameter(oNewID + '/time/recurrenceBase', 'weekly');
                if (oTriggerNode.getChild('weekdays')!=null) {
                    var sText=oTriggerNode.getChild('weekdays').getValue();
                    var oArray=sText.split(',');
                    for (var kIndex=0;kIndex<oArray.length;kIndex++) {
                        if (oArray[kIndex]=='0')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'SU');
                        if (oArray[kIndex]=='1')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'MO');
                        if (oArray[kIndex]=='2')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'TU');
                        if (oArray[kIndex]=='3')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'WE');
                        if (oArray[kIndex]=='4')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'TH');
                        if (oArray[kIndex]=='5')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'FR');
                        if (oArray[kIndex]=='6')
                            storeSubParameter(oNewID + '/time/recurrence/' + kIndex, 'SA');
                    }
                } else if (oTriggerNode.getChild('recurrence')!=null) {
                    for (var kIndex=0;kIndex<oTriggerNode.getChild('recurrence').getChildren().length;kIndex++) {
                        storeSubParameter(oNewID + '/time/recurrence/' + kIndex, oTriggerNode.getChild('recurrence').getChildren()[kIndex].getValue());
                    }
                }
                
                
            } else {
                // einzelnes
                storeSubParameter(oNewID + '/time/recurrenceBase', 'absolute');
                storeSubParameter(oNewID + '/time/date/0', oTriggerNode.getChild('recurrence/0').getValue()); // 2012-02-07
              //time : timebase: 'absolute', 'daily', 'sunrise', 'sunset' | offset: seconds
            }
            var sTime=oTriggerNode.getChild('time').getValue();
            if (sTime.indexOf('sunrise')!=-1)
            {
                storeSubParameter(oNewID + '/time/timeBase', 'sunrise');
                sTime=sTime.substring(7);
                var oArray=sTime.split(':');
                var oTimeDiv=Math.abs(parseInt(oArray[2],10));
                oTimeDiv+=Math.abs(parseInt(oArray[1],10))*60;
                oTimeDiv+=Math.abs(parseInt(oArray[0],10))*60*60;
                if (oTimeDiv!=0)
                    if (oArray[0].indexOf('-')==0)
                        oTimeDiv*=-1;
                storeSubParameter(oNewID + '/time/offset', oTimeDiv);
            } else if (sTime.indexOf('sunset')!=-1)
            {
                storeSubParameter(oNewID + '/time/timeBase', 'sunset');
                sTime=sTime.substring(6);
                var oArray=sTime.split(':');
                var oTimeDiv=Math.abs(parseInt(oArray[2],10));
                oTimeDiv+=Math.abs(parseInt(oArray[1],10))*60;
                oTimeDiv+=Math.abs(parseInt(oArray[0],10))*60*60;
                if (oTimeDiv!=0)
                    if (oArray[0].indexOf('-')==0)
                        oTimeDiv*=-1;
                storeSubParameter(oNewID + '/time/offset', oTimeDiv);
            } else {
                storeSubParameter(oNewID + '/time/timeBase', 'daily');
                var oArray=sTime.split(':');
                var oTimeDiv=Math.abs(parseInt(oArray[2],10));
                oTimeDiv+=Math.abs(parseInt(oArray[1],10))*60;
                oTimeDiv+=Math.abs(parseInt(oArray[0],10))*60*60;
                if (oTimeDiv!=0)
                    if (oArray[0].indexOf('-')==0)
                        oTimeDiv*=-1;
                storeSubParameter(oNewID + '/time/offset', oTimeDiv);
            }    
            
            lInfo.logln("done. Delete old Node " + oTriggerNode.getPath());
            baseNodes.removeChild(oTriggerNode);
        }
        catch (e)
        {
            lWarn.logln("Fehler beim Datenupgrade " + e);
            if (Property.getNode('entries')!=null)
                Property.getNode('entries').removeChild(oNewID);
            fError=true;
        }        
    }
    if (!fError) {
        lInfo.logln("All done. Delete old Node");
        Property.getNode('/scripts/system-addon-timed-events').removeChild('events');
    }
    Property.store();
    lInfo.logln("Raising Running Signal!");
    var evt = new Event("system-addon-timed-events.running", {});
    evt.raise();
}


function updateScopeAndDeleteCounter() {
	 // adding scope variable
	try {
		var fMigrate=false;
		lInfo.logln('Checke nach system-addon-timed-events - scope & deleteCounter');
		var basePropertyArray = Property.getNode('entries');
		if (basePropertyArray!=null) {
			var subPropArray = basePropertyArray.getChildren();
			for ( var iIndex = 0; iIndex < subPropArray.length; iIndex++) {
				lInfo.logln('values found ' + iIndex);
	       if (subPropArray[iIndex].getChild('scope')==null) {
	    	   fMigrate=true;
	           Property.setProperty(subPropArray[iIndex].getPath()+'/scope','system-addon-timed-events');
	           Property.setFlag(subPropArray[iIndex].getPath()+'/scope','ARCHIVE',true);
	       }
	       if (subPropArray[iIndex].getChild('deleteCounter')==null) {
	    	   fMigrate=true;
	           Property.setProperty(subPropArray[iIndex].getPath()+'/deleteCounter',0);
	           Property.setFlag(subPropArray[iIndex].getPath()+'/deleteCounter','ARCHIVE',true);
	           }
	       }
	   }
	   
	   if (fMigrate)
	       Property.store();
	   else
	       lInfo.logln('nothing to update - scope & deleteCounter');
	}
   catch (e)
   {
       lWarn.logln("Fehler beim updateScopeAndDeleteCounter " + e);
   }  
}

updateData();
updateScopeAndDeleteCounter();