
function getParameterByName(name)
{
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}


Ext.define('DSS.addon.TimedEvents', {
	fExpertMode:false,
    extend: 'DSS.addon.Framework',

    config: {
        appName: 'te_title',
        appId: 'system-addon-timed-events',
        appVersion: '1.4.5',
        appIcon: 'images/app_icon.png'
    },

    getHelp: function() {
        return Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            padding : '0 20 0 0', //top right bottom left
            loader: {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad: true,
                disableCaching: false
            }
        });
    },

    getContent: function() {
        
        var me=this;
        /* Parameter:
         *   * editor config
         *   * button config
         *   * store config   
         *   * columns
         *   * defaultSortCol
         * */
        
        var oConfig={
                defaultSortCol:'name',
                disabledProperty:'disabled',
                storeConfig: {
                    storeId : 'timedeventStore',
                    fields : [ {name:'id'}, 
                               {name:'disabled', sortType:'asBoolean'}, 
                               {name:'name', sortType:'asUCText'}, 
                               {name:'actions', sortType:'asAction'}, 
                               {name:'time', sortType:'asTime'}, 
                               {name: 'conditions',  sortType: 'asCondition' },
                               {name: 'grouping',  sortType: 'asUCText' },
                               {name:'recurrence', sortType:'asRecurrence'} ,
                               {name:'deleteCounter', sortType:'asUCText'}
                               ]  
                },
                multiselect:true,
                columns: [{
                    header : _('Active'),
                    dataIndex : 'disabled',
                    resizable : false,
                    xtype: 'disabledcolumn', 
                    width : 50
                }, {
                    header : _('Name'),
                    dataIndex : 'name',
                    xtype: 'textcolumn', 
                    width : 200
                }, {
                    header : _('Activity'),
                    dataIndex : 'actions', 
                    maintainFlex : true,
                    flex : 5,
                    xtype: 'actioncolumn'
                }, {
                    header: _('Time'),
                    dataIndex: 'time',
                    xtype: 'timecolumn', 
                    width: 200
                }, {
                    header: _('Recurrence'),
                    dataIndex: 'recurrence',
                    xtype: 'recurrencecolumn', 
                    width: 160
                },{
                    header: _('Conditions'),
                    dataIndex: 'conditions', 
                    xtype: 'conditioncolumn',
                    maintainFlex: true,
                    flex: 3,
                    customRendererOptions:{hideEnabled:true,hideWeekdays:false,hideGenericSystemStates:false,hideZoneStates:false,hideTimeframe:false,filterSystemState:[],
                    	stateTitles:[{name:'daylight',value:true,title:_('grid_daylight_true')},{name:'daylight',value:false,title:_('grid_daylight_false')},
                    	             {name:'daynight',value:true,title:_('grid_daynight_true')},{name:'daynight',value:false,title:_('grid_daynight_false')},
                    	             {name:'panic',value:'1',title:_('grid_panic_active')},{name:'panic',value:'2',title:_('grid_panic_inactive')},
                    	             {name:'presence',value:'present',title:_('grid_presence_present')},{name:'presence',value:'absent',title:_('grid_presence_absent')},
                    	             {name:'fire',value:'1',title:_('grid_fire_active')},{name:'fire',value:'2',title:_('grid_fire_inactive')},
                    	             {name:'hail',value:'1',title:_('grid_hail_active')},{name:'hail',value:'2',title:_('grid_hail_inactive')},
                    	             {name:'wind',value:'1',title:_('grid_wind_active')},{name:'wind',value:'2',title:_('grid_wind_inactive')},
                    	             {name:'rain',value:'1',title:_('grid_rain_active')},{name:'rain',value:'2',title:_('grid_rain_inactive')},
                    	             {name:'frost',value:'1',title:_('grid_frost_active')},{name:'frost',value:'2',title:_('grid_frost_inactive')},
                    	             {name:'sun',value:'1',title:_('grid_sun_active')},{name:'sun',value:'2',title:_('grid_sun_inactive')},
                    	             {name:'service',value:'1',title:_('grid_service_active')},{name:'service',value:'2',title:_('grid_service_inactive')},
                    	             {name:'alarm',value:'1',title:_('grid_alarm_active')},{name:'alarm',value:'2',title:_('grid_alarm_inactive')},
                    	             {name:'alarm2',value:'1',title:_('grid_alarm2_active')},{name:'alarm2',value:'2',title:_('grid_alarm2_inactive')},
                    	             {name:'alarm3',value:'1',title:_('grid_alarm3_active')},{name:'alarm3',value:'2',title:_('grid_alarm3_inactive')},
                    	             {name:'alarm4',value:'1',title:_('grid_alarm4_active')},{name:'alarm4',value:'2',title:_('grid_alarm4_inactive')},
                    	             {name:'holiday', value:'on',title:_('grid_holiday_on')},{name:'holiday', value:'off',title:_('grid_holiday_off')}]}
                }],     
                buttonText: {
                    newButton: _('New event'),
                    editButton: _('Edit event'),
                    enableButton:_('Enable event'),
                    disableButton:_('Disable event'),
                    testButton: _('Test event'),
                    deleteButton: _('Delete event')
                },
                defaultNewEntryValues: {
                	conditions:{systemState:[{name:'holiday',value:'off'}]}
                },
                editorConfig:{
                    title : _('Timed Event'),
                    staticControls : [ {
                        type : 'text',
                        label : _('Name'),
                        id : 'name'
                    }, {
                        type: 'hidden',
                        label: 'id',
                        id: 'id'
                    }],
                    tabControls : [{
                        tabLabel : _('time of execution'),
                        tabDescription : _('Choose the time, when the activities should be executed.'),
                        content : [{
                                label: _('Time'),
                                type : 'timeReference',
                                id : 'time'
                           },{
                               type : 'weekdaySelection',
                               id : 'recurrence',
                               label: _('Recurrence'),
                               flex : true
                          }]
                    }, {
                        tabLabel : _('Activity'),
                        tabDescription : _('Choose the activities, which should be executed.'),
                        content : [{
                            type : 'ActionConfigurator',
                            id : 'actions',
                            flex : true,
                            heatingOperationMode:true,
                            withDelay : true
                        }]
                    }, {
                        tabLabel : _('Conditions'),
                        tabDescription : _('Choose the conditions.'),
                        content : [{
                            type : 'ConditionConfigurator',
                            id : 'conditions',
                            conditions:[
                                        {type:'singleItem',title:_('state_daynight'),entry:[
                                              {type:'state',name:'daylight',value:true,title:Ext.String.format2(_('daynight_bright'),{
		                                            	duskTime:dss.staticDataModel.getDusk(),
		                                            	dawnTime:dss.staticDataModel.getDawn()
		                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_true'),{
		                                            	duskTime:dss.staticDataModel.getDusk(),
		                                            	dawnTime:dss.staticDataModel.getDawn()
		                                            })},
                                              {type:'state',name:'daylight',value:false,title:Ext.String.format2(_('daynight_dark'),{
	                                            	duskTime:dss.staticDataModel.getDusk(),
	                                            	dawnTime:dss.staticDataModel.getDawn()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_false'),{
	                                            	duskTime:dss.staticDataModel.getDusk(),
	                                            	dawnTime:dss.staticDataModel.getDawn()
	                                            })},
                                              {type:'state',name:'daynight',value:true,title:Ext.String.format2(_('daynight_day'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_true'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            })},
                                              {type:'state',name:'daynight',value:false,title:Ext.String.format2(_('daynight_night'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_false'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            })}
	                                            
	                                            ]},
                                        {type:'timeframe',title:_('Timeframe')},
	                                    {type:'deviceState',title:_('automatic devices')},
                                        {type:'singleItem',title:_('state_presence'),entry: [
                                               {type:'state',name:'presence',value:'present',title:_('presence_present'),gridText:_('grid_presence_present')},
                                               {type:'state',name:'presence',value:'absent',title:_('presence_absent'),gridText:_('grid_presence_absent')}]},                                               
                                        {type:'singleItem',title:_('state_holiday'),entry: [
                                               {type:'state',name:'holiday',value:'on',title:_('holiday_on'),gridText:_('grid_holiday_on')},
                                               {type:'state',name:'holiday',value:'off',title:_('holiday_off'),gridText:_('grid_holiday_off')}]},
	                                   {type:'multiItem',title:_('weather trigger'),entry: [
	                                            {type:'state',name:'rain',value:'1',title:_('rain active'),gridText:_('grid_rain_active'),group:1},
	                                            {type:'state',name:'rain',value:'2',title:_('rain inactive'),gridText:_('grid_rain_inactive'),group:1},
	                                            {type:'state',name:'wind',value:'1',title:_('wind active'),gridText:_('grid_wind_active'),group:2},
	                                            {type:'state',name:'wind',value:'2',title:_('wind inactive'),gridText:_('grid_wind_inactive'),group:2},
	                                            {type:'state',name:'hail',value:'1',title:_('hail active'),gridText:_('grid_hail_active'),group:3},
                                               {type:'state',name:'hail',value:'2',title:_('hail inactive'),gridText:_('grid_hail_inactive'),group:3},
                                               {type:'state',name:'frost',value:'1',title:_('frost active'),gridText:_('grid_frost_active'),group:4},
                                               {type:'state',name:'frost',value:'2',title:_('frost inactive'),gridText:_('grid_frost_inactive'),group:4},
                                               {type:'state',name:'sun',value:'1',title:_('sun active'),gridText:_('grid_sun_active'),group:5},
                                               {type:'state',name:'sun',value:'2',title:_('sun inactive'),gridText:_('grid_sun_inactive'),group:5}]},
                                               {type:'state',name:'service',value:'1',title:_('service active'),gridText:_('grid_service_active'),group:6},
                                               {type:'state',name:'service',value:'2',title:_('service inactive'),gridText:_('grid_service_inactive'),group:6},
	                                   {type:'multiItem',title:_('Security'),entry: [
	                                           {type:'state',name:'fire',value:'1',title:_('fire active'),gridText:_('grid_fire_active'),group:1},
	                                           {type:'state',name:'fire',value:'2',title:_('fire inactive'),gridText:_('grid_fire_inactive'),group:1},
	                                            {type:'state',name:'panic',value:'1',title:_('panic_active'),gridText:_('grid_panic_active'),group:2},
	                                            {type:'state',name:'panic',value:'2',title:_('panic_inactive'),gridText:_('grid_panic_inactive'),group:2},
	                                            {type:'state',name:'alarm',value:'1',title:_('alarm_active'),gridText:_('grid_alarm_active'),group:3},
	                                            {type:'state',name:'alarm',value:'2',title:_('alarm_inactive'),gridText:_('grid_alarm_inactive'),group:3},
	                                            {type:'state',name:'alarm2',value:'1',title:_('alarm2_active'),gridText:_('grid_alarm2_active'),group:4},
	                                            {type:'state',name:'alarm2',value:'2',title:_('alarm2_inactive'),gridText:_('grid_alarm2_inactive'),group:4},
	                                            {type:'state',name:'alarm3',value:'1',title:_('alarm3_active'),gridText:_('grid_alarm3_active'),group:5},
	                                            {type:'state',name:'alarm3',value:'2',title:_('alarm3_inactive'),gridText:_('grid_alarm3_inactive'),group:5},
	                                            {type:'state',name:'alarm4',value:'1',title:_('alarm4_active'),gridText:_('grid_alarm4_active'),group:6},
	                                            {type:'state',name:'alarm4',value:'2',title:_('alarm4_inactive'),gridText:_('grid_alarm4_inactive'),group:6}]},
                                        {type:'zonestate',title:_('ZoneState')},
                                        {type:'clusterstate',title:_('Cluster State')}
                            ],
                            flex : true
                        }]
                    }]
                },
                listeners: {
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){                        
                        me.waitAndReload(grid,{
                            actions : 'save',
                            value : Ext.JSON.encode(values)
                        });
                    },
                    'enableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        me.waitAndReload(grid,{
                            actions : 'enable',
                            id : Ext.JSON.encode(idVal)
                        });
                     },
                    'disableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        me.waitAndReload(grid,{
                            actions : 'disable',
                            id : Ext.JSON.encode(idVal)
                        });
                    },
                    'deleteEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        me.waitAndReload(grid,{
                            actions : 'delete',
                            id : Ext.JSON.encode(idVal)
                        });
                    },
                    'testEntry':function (grid,entry){
                        dss.ajaxAssyncRequestWithoutAnswer("/json/event/raise",
                                {name:'action_execute', parameter:  "path=/scripts/system-addon-timed-events/entries/" + entry.get('id')  + ";ignoreConditions=ignoreConditions"});                       
                    }
                }
        };
                      
        
        if (getParameterByName('mode')=='expert') {
            oConfig.editorConfig.tabControls[1].content[0].withDelay=true;
            oConfig.editorConfig.tabControls[1].content[0].enableUsergroup=true;
            oConfig.editorConfig.tabControls[1].content[0].userStates=true;
            oConfig.editorConfig.tabControls[1].content[0].heatingOperationMode=true;
            oConfig.editorConfig.tabControls[1].content[0].heatingExtendedOperationMode=true;
            oConfig.editorConfig.tabControls[1].content[0].UMRExtendetFunctions=true;
            oConfig.editorConfig.tabControls[0].content[0].randomize=1800;
            oConfig.editorConfig.tabControls[0].content.push(
            {
                type : 'number',
                label : _('Wiederholungen'),
                id : 'deleteCounter',
                minValue:-1,
                maxValue:1000
            });
            oConfig.defaultNewEntryValues={deleteCounter:-1};
            oConfig.grouperField='grouping';
            this.fExpertMode=true;
        }
        return Ext.create('DSS.gridPanel', oConfig);
    },
    waitAndReload : function(grid,parameter) {
    	grid.setStatus(_('Saving ...'));
    	grid.setDisabled(true);
    	
    	
    	var me = this;
    	dss.pushAndQuery('system-addon-timed-events.config',parameter,
    			         'system-addon-timed-events.saved',function(eventData) {
    		 me.loadParameter(grid);
    		 return true;
    	});
    	

    },
    loadParameter : function(grid) {
    	grid.setStatus(_('Loading ...'));
    	grid.setDisabled(true);
        var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/system-addon-timed-events/entries/*(*)/*(*)/*(*)/*(*)'
        });
        var result = Ext.JSON.decode(sString);
        var oTimedEvent=dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                             {name:'id',type:'simple'},
                                                             {name:'random',type:'simple'},
                                                             {name:'metaData',type:'simple'},
                                                             {name:'disabled',type:'condition/enabled'},
                                                             {name:'holiday',type:'condition/state'},
                                                             {name:'actions',type:'action'},
                                                             {name: 'conditions', type: 'condition'},
                                                             {name:'time',type:'time'},  //time : timebase: 'absolute', 'daily', 'sunrise', 'sunset' | offset: seconds
                                                             {name:'recurrence',type:'recurrence'},
                                                             {name:'deleteCounter',type:'simple'}]);  // recurrence:  0 : MO,TU,WE,TH,FR,SA,SO        
        if (oTimedEvent!=null) {
            var oResultObject=[];
            for (var iIndex=0;iIndex<oTimedEvent.length;iIndex++) {
                var fAdd=true;
                oTimedEvent[iIndex].grouping=unescape(oTimedEvent[iIndex].name).split(' ')[0];
                if (!this.fExpertMode) {
	                if (oTimedEvent[iIndex]['holiday']!=null)
	                    if (oTimedEvent[iIndex]['holiday']=='on')
	                        fAdd=false;
                } 
                if (fAdd)
                    oResultObject.push(oTimedEvent[iIndex]);
            }
            grid.loadParameter(oResultObject);
            
        }
        grid.setStatus(_('Ready'));
        grid.setDisabled(false);
    }
});

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/timed-events.po']);
    var timedevents = Ext.create('DSS.addon.TimedEvents');
    timedevents.initPage();
});

